unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, RVStyle, RVScroll, RichView, StdCtrls;

type
  TForm1 = class(TForm)
    RichView1: TRichView;
    RVStyle1: TRVStyle;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// A4 width in twips (1 inch = 1440 twips)
const A4Width = 11906;
      A4Height = 16838;

procedure CreateRTFWithSections(const RVFFiles: array of String;
  const IsLandscape: array of Boolean;
  const RTFFile: String; rv: TCustomRichView);
var i, ParaNo: Integer;
    Stream: TFileStream;
begin
  rv.Clear;
  with rv.Style do begin
    TextStyles.Clear;
    TextStyles.Add;
    with TextStyles.Add do begin
      Options := [rvteoRTFCode];
      Size := 1;
    end;
    ParaStyles.Clear;
    ParaStyles.Add;
    ListStyles.Clear;
  end;
  for i := Low(RVFFiles) to High(RVFFiles) do
    try
      Stream := TFileStream.Create(RVFFiles[i], fmOpenRead);
      try
          ParaNo := 0;
          if i<>0 then begin
            rv.AddNL('\sect\sectd', 1, ParaNo);
            ParaNo := -1;
          end;
          if IsLandscape[i] then
            rv.AddFmt('\lndscpsxn\pgwsxn%d\pghsxn%d', [A4Height, A4Width], 1, ParaNo)
          else
            rv.AddFmt('\pgwsxn%d\pghsxn%d', [A4Width, A4Height], 1, ParaNo);
          rv.InsertRVFFromStream(Stream, rv.ItemCount);
      finally
        Stream.Free;
      end;
    except
      rv.AddNL('Error loading file', 0, 0);
    end;
  rv.SaveRTF(RTFFile, False);
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
  CreateRTFWithSections(
    ['doc1.rvf', 'doc2.rvf', 'doc3.rvf'],
    [False, True, False], 'Result.rtf', RichView1);
  RichView1.Format;
end;

end.
